--[[
ARMAGEDDON v0.8
Reste à faire :
[X] Animer le vaisseau lors des mouvements
[ ] Jouer plusieurs sons simultanément
[ ] Gérer plusieurs vies
[ ] Gérer des bonus et des armes différentes
[ ] Installer des boucliers sur les villes
[ ] Gérer des points de vie pour les bouclier.
]]--



debug = false
height = love.graphics.getHeight( )
width = love.graphics.getWidth( )
deg2rad=0.0174533

isAlive = true
gamePlay = false
helpScreen = false
score = 0

-- Collision detection taken function from http://love2d.org/wiki/BoundingBox.lua
function CheckCollision(x1,y1,w1,h1, x2,y2,w2,h2)
  return x1 < x2+w2 and
         x2 < x1+w1 and
         y1 < y2+h2 and
         y2 < y1+h1
end
  
function animation (liste, image, sprite)    
  for i, anim in ipairs(liste) do
    love.graphics.draw(image, sprite[math.floor(anim.frame)], anim.x, anim.y)
  end
end
  
function afficheHelpScreen()  
  love.graphics.setColor(255, 255, 255)
  love.graphics.rectangle("fill", (width - titleImg:getWidth())/2, (width - titleImg:getWidth())/2, titleImg:getWidth(), height - ((width - titleImg:getWidth())/2)*2)
  love.graphics.setColor(64, 64, 64)
  love.graphics.rectangle("fill", (width - titleImg:getWidth())/2+10, (width - titleImg:getWidth())/2+10, titleImg:getWidth()-20, height - ((width - titleImg:getWidth())/2)*2-20)
  love.graphics.setColor(255, 255, 255)
  love.graphics.draw(keyboardImg, (width - keyboardImg:getWidth())/2, (width - keyboardImg:getWidth())/3)    
  
  love.graphics.setColor(255, 255, 255)
  love.graphics.print("Controls :", 200, love.graphics:getHeight()/8+25)
  love.graphics.setColor(0, 255, 33)
  love.graphics.print("Move your ship.", 200, 5*love.graphics:getHeight()/8)
  love.graphics.setColor(255, 0, 0)
  love.graphics.print("fire laser.", 200, 5*love.graphics:getHeight()/8+25)
  love.graphics.setColor(255, 0, 110)
  love.graphics.print("Start Game.", 200, 5*love.graphics:getHeight()/8+50)
  love.graphics.setColor(255, 106, 0)
  love.graphics.print("Escape Game.", 200, 5*love.graphics:getHeight()/8+75)
  love.graphics.setColor(0, 148, 255)
  love.graphics.print("Show / hide Help screen.", 200, 5*love.graphics:getHeight()/8+100)
  love.graphics.setColor(255, 255, 255)
end

function afficheDebug()  
    love.graphics.setColor(255, 255, 255)
    decalage=0
    love.graphics.print("Lasers : "..#bullets, width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
    love.graphics.print("Asteroids : "..#rocks, width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
    love.graphics.print("Clouds : "..#clouds, width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
    love.graphics.print("FPS : "..tostring(love.timer.getFPS( )), width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
    love.graphics.print("createRockOriginal : "..createRockOriginal, width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
    love.graphics.print("createRockTimerMax : "..createRockTimerMax, width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
    love.graphics.print("deltaScore : "..deltaScore, width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
    love.graphics.print("k : "..#sPlayer, width-200, love.graphics:getHeight()/2+decalage)
    decalage = decalage + hauteurFont
end

function afficheTitleScreen()
  love.graphics.draw(titleImg, (width - titleImg:getWidth())/2, (width - titleImg:getWidth())/2)
  love.graphics.setFont(font16)
  love.graphics.setColor(33, 30, 0)
  love.graphics.print("Press <F1> to help.", 100, love.graphics:getHeight()/2)
  love.graphics.print("Press <Enter> to start the game.", 100, love.graphics:getHeight()/2+25)
  love.graphics.setColor(255, 255, 255)
end

function afficheGameOver()  
  love.graphics.draw(gameOverImg, (width - gameOverImg:getWidth())/2, (width - gameOverImg:getWidth())/2)
end

function initialize()
    bullets = {}
    rocks = {}
    citiesCreate()

    -- reset timers
    canShootTimer = canShootTimerMax
    createRockTimerMax = createRockOriginal

    -- On replace le joueur à sa position initiale
    player.x = width/2-playerWidth/2
    player.y = height-playerHeight-10 - cityImg:getHeight() -groundWidth

    -- reset des données du jeu
    score = 0
    deltaScore=0
    isAlive = true
end

function citiesCreate()
  nbCities = math.floor( width / cityImg:getWidth())
  intevervalCities = math.floor((width - (nbCities*cityImg:getWidth())) / (nbCities+1))  
  for i = 1, nbCities do
    newCity = { x = i*intevervalCities + (i-1) * cityImg:getWidth(), y=height-groundWidth-cityImg:getHeight(), img=cityImg }
    table.insert(cities, newCity)
  end
end

-- Timers
canShoot = true
canShootTimerMax = 0.10
canShootTimer = canShootTimerMax
canCreateRock = true
createRockOriginal = 1
createRockTimerMax = 1
createRockTimer = createRockTimerMax
maxClouds = 15
deltaScore = 0
groundWidth = 25

-- Image Storage
playerImg     = nil
bulletImg     = nil
rockImg       = nil
cityImg       = nil
explosionImg  = nil
littleRockImg = nil

-- Entity Storage
player      = { x = 0, y = 0, speed = 400, img = nil }
sPlayer     = {}
bullets     = {}
sLaser      = {}
stars       = {}
clouds      = {}
cities      = {}
rocks       = {}
sRock       = {}
indices     = {9,1,3,8,0,2,12,4,6}

explosions  = {}  -- Liste des explosions à afficher
sExplosion  = {}  -- Sprites pour animer l'explosion
champignons = {}
sChampignon = {}

function aleatoire(min, max)
  math.randomseed( os.time() )
  nombreAleatoire = math.floor( math.random() * (max-min))  - min
  return nombreAleatoire
end
    

--  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
--  L  O  A  D 
--  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function love.load(arg)
  font16 = love.graphics.newFont("assets/font16bit.ttf", 16)
  hauteurFont = font16:getHeight("L")
  fontPixelArt = love.graphics.newFont("assets/pixelArt.ttf", 16)
  
  bulletImg       = love.graphics.newImage('assets/laser.png')
  cityImg         = love.graphics.newImage('assets/city.png')
  cloudImg        = love.graphics.newImage('assets/cloud.png')
  titleImg        = love.graphics.newImage('assets/title.png')
  gameOverImg     = love.graphics.newImage('assets/gameOver.png')
  keyboardImg     = love.graphics.newImage('assets/keyboard.png')
  
  littleRockImg   = love.graphics.newImage('assets/littleRock.png')
  offsetLittleRock = littleRockImg:getHeight()/2
  
  gunSound        = love.audio.newSource("assets/gun-sound.wav", "static")
  explosionSound  = love.audio.newSource("assets/sfx-explosion.wav", "static")
  
  -- Gestion des sprites des ennemis  ---------------------------------------------------------------------------------------------
  rockImg        = love.graphics.newImage('assets/rock.png')
  offsetRock = rockImg:getHeight()/2
  
  -- Gestion des sprites du player  -----------------------------------------------------------------------------------------------
  playerImg = love.graphics.newImage('assets/spriteSheet.png')  
  playerHeight = 43
  playerWidth = 39
  k=1
  for i=0, 2 do
    for j=0, 2 do
      print(k.." "..indices[k])
      sPlayer[indices[k]] = love.graphics.newQuad(playerWidth*j, playerHeight*i, playerWidth, playerHeight, playerImg:getDimensions())
      k=k+1
    end
  end
  
  -- Gestion des sprites de l'explosion  ------------------------------------------------------------------------------------------
  explosionImg  = love.graphics.newImage('assets/explosionB.png')  
  nbFrameExplosion = explosionImg:getWidth()/explosionImg:getHeight()
  frameSize = explosionImg:getHeight()
  offsetExplosion = explosionImg:getHeight()/2
  for i = 0, nbFrameExplosion do
    sExplosion[i] = love.graphics.newQuad(frameSize*i, 0, frameSize, frameSize, explosionImg:getDimensions())
  end
  
  -- Gestion des Sprites du Champignon atomique  ----------------------------------------------------------------------------------
  champignonImg = love.graphics.newImage('assets/champignon.png')
  nbFrameChampignon = champignonImg:getWidth()/champignonImg:getHeight()
  frameSize = champignonImg:getHeight()  
  offsetChampignion = champignonImg:getHeight()/2
  for i = 0, nbFrameChampignon do
    sChampignon[i] = love.graphics.newQuad(frameSize*i, 0, frameSize, frameSize, champignonImg:getDimensions())
  end
  
  -- Gestion des Sprites des lasers  ----------------------------------------------------------------------------------------------
  laserImg  = love.graphics.newImage('assets/laser.png')  
  nbFrameLaser = 4
  frameSize = laserImg:getWidth()/nbFrameLaser  
  offsetLaser = laserImg:getWidth()/nbFrameLaser/2
  for i = 0, nbFrameLaser do
    sLaser[i] = love.graphics.newQuad(frameSize*i, 0, frameSize, laserImg:getHeight() , laserImg:getDimensions())
  end
    
  -- Creation des NUAGES ----------------------------------------------------------------------------------------------------------
  for i = 1, maxClouds do
    newCloud = {x=math.random(width), y=math.random(height-200), speed=math.random(30) }
    table.insert(clouds, newCloud)
  end
  
  -- Creation des CITES -----------------------------------------------------------------------------------------------------------
  citiesCreate()
  
  -- Définition du PLAYER ---------------------------------------------------------------------------------------------------------
  player.x = width/2-playerWidth/2
  player.y = height-playerHeight-10 - cityImg:getHeight() -groundWidth
  player.frame = 7
  
end


--  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
--  U  P  D  A  T  E
--  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function love.update(dt)  
  player.frame = 0
  
  -- Manche à GAUCHE
	if love.keyboard.isDown('left','q') then
    player.frame = player.frame + 8
    if player.x>0 then
      player.x = player.x - (player.speed*dt)
    end
    
  -- Manche à DROITE
	elseif love.keyboard.isDown('right','d') then
    player.frame = player.frame + 2
    if player.x<love.graphics.getWidth()-playerWidth then
      player.x = player.x + (player.speed*dt)
    end	
  end
    
  -- Manche en HAUT
	if love.keyboard.isDown('up','z') then
    player.frame = player.frame + 1
    if player.y>0 then
      player.y = player.y - (player.speed*dt)
    end	
    
  -- Manche en BAS
	elseif love.keyboard.isDown('down','s') then
    player.frame = player.frame + 4
    if player.y<love.graphics.getHeight()-playerHeight then
      player.y = player.y + (player.speed*dt)
    end
  end
  
  -- Quand on appuie sur la GACHETTE
	if love.keyboard.isDown('space', 'rctrl', 'lctrl', 'ctrl') and canShoot and isAlive then    
    newBullet = {x=player.x+playerWidth/2, y=player.y, img=laserImg , frame=0, speedAnim = 4}   -- On crée une nouvelle munition
    table.insert(bullets, newBullet)                      -- Qu'on insère dans la liste des projectiles à gérer
    canShoot = false                                       -- Et on réinitialise le timer (pour recharger le canon)
    gunSound:play()
    canShootTimer=canShootTimerMax
	end
  
  -- Réinitialisation pour une nouvelle partie
  if not isAlive and love.keyboard.isDown('r') then
    initialize()
  end
  
  -- On recharge le canon
  canShootTimer = canShootTimer - (1 * dt)
  if canShootTimer < 0 then
    canShoot = true
  end
  
  -- Gestion du timer autorisant la génération d'un ROCK
  createRockTimer = createRockTimer - (1 * dt)
  if createRockTimer < 0 then
    canCreateRock = true
  end
  
  -- Gestion des mouvements de chaque PROJECTILE
  for i, bullet in ipairs(bullets) do
    bullet.y = bullet.y- (500 * dt)
    if bullet.y<0 then
      table.remove(bullets, i)
    end
  end
  
  -- Gestion des mouvements des NUAGES
  for i, cloud in ipairs(clouds) do
    cloud.x = cloud.x+ (cloud.speed * dt)
    if cloud.x>width then
      table.remove(clouds, i)
      newCloud = {x=-cloudImg:getWidth() , y=math.random(0,height-200), speed=math.random(30)}
      table.insert(clouds, newCloud)
    end    
  end
  
  -- Si c'est autorisé, on crée un ASTEROID
  if canCreateRock then
    --randomNumber = aleatoire(0, love.graphics.getWidth() - rockImg:getWidth()) --
    randomNumber = math.random(0, love.graphics.getWidth() - rockImg:getWidth())
    newRock = { size        = 1, 
                x           = randomNumber, 
                y           = -50, 
                img         = rockImg, 
                speed       = math.random(10,100), 
                score       = 50,
                speedAnim   = math.random(1,4)*10, 
                angle       = math.random(-3, 360), 
                speedAngle  = math.random(1,3), 
                deltaX      = 0, 
                deltaY      = 1, 
                offset      = offsetRock}
    table.insert(rocks, newRock)
    canCreateRock = false
    
    if deltaScore > 1500 then
      createRockTimerMax = createRockTimerMax * 0.98
      deltaScore = 0
    end
    createRockTimer = createRockTimerMax
  end
  
  -- Gestion des mouvements de chaque rock
  for i, rock in ipairs(rocks) do
    rock.angle = rock.angle + (rock.speedAngle * dt)
    rock.x = rock.x+ (rock.speed * rock.deltaX * dt)   
    rock.y = rock.y+ (rock.speed * rock.deltaY * dt)    
    if rock.y>height-groundWidth then
      table.remove(rocks, i)
    end    
  end
    
  -- Gestion de l'animation des explosions
  for i, explosion in ipairs(explosions) do
    explosion.frame = explosion.frame + 1
    if explosion.frame>nbFrameExplosion-1 then
      table.remove(explosions, i)
    end
  end
    
  -- Gestion de l'animation des champignions
  for i, champignon in ipairs(champignons) do
    champignon.frame = champignon.frame + (nbFrameChampignon * dt)
    if champignon.frame>nbFrameChampignon -1 then
      table.remove(champignons, i)
    end
  end
    
  -- Gestion de l'animation des lasers
  for i, bullet in ipairs(bullets) do
    bullet.frame = bullet.frame + (bullet.speedAnim * dt)
    if bullet.frame>nbFrameLaser then
       bullet.frame = 0
    end
  end
  
  if gamePlay then
    -- Detection de colision à partir d'un GROS ASTEROID
    for i, rock in ipairs(rocks) do
      -- avec des munitions :
      for j, bullet in ipairs(bullets) do
        if CheckCollision(rock.x-rock.offset, rock.y-rock.offset, rock.img:getWidth(), rock.img:getHeight(), bullet.x, bullet.y, bullet.img:getWidth()/4, bullet.img:getHeight()) then
          score = score + rock.score
          deltaScore = deltaScore + rock.score
          
          -- Un gros astéroid se sépare en 2 petits
          if rock.size ==  1 then 
            angle = math.random(0,20)*deg2rad        
            newRock = { size = 2, 
                        x=rock.x, 
                        y=rock.y, 
                        img=littleRockImg, 
                        speed=rock.speed,
                        score=100,
                        speedAnim=rock.speedAnim, 
                        angle=math.random(0, 360), 
                        speedAngle=math.random(0,3), 
                        deltaX = math.sin(angle), 
                        deltaY = math.cos(angle), 
                        offset = offsetLittleRock}
            table.insert(rocks, newRock)
            
            newRock = { size = 2, 
                        x=rock.x, 
                        y=rock.y, 
                        img=littleRockImg, 
                        speed=rock.speed, 
                        score=100,
                        speedAnim=rock.speedAnim, 
                        angle=math.random(0, 360), 
                        speedAngle=math.random(0,3), 
                        deltaX = -math.sin(angle), 
                        deltaY = math.cos(angle), 
                        offset = offsetLittleRock}                      
            table.insert(rocks, newRock)
          end
          
          newExplosion = {frame=0, x=rock.x+rock.offset-offsetChampignion, y=rock.y+rock.offset-offsetExplosion}
          table.insert(explosions, newExplosion)
          explosionSound:play()
          table.remove(bullets, j)
          table.remove(rocks, i)
          
        end
      end
      
      -- avec des cités
      for j, city in ipairs(cities) do
        if CheckCollision(rock.x-rock.offset, rock.y-rock.offset, rock.img:getWidth(), rock.img:getHeight(), city.x, city.y, city.img:getWidth(), city.img:getHeight()) then
          newChampignion = {frame=0, x=city.x+city.img:getWidth()/2-champignonImg:getWidth()/nbFrameChampignon/2, y=height-groundWidth-champignonImg:getHeight()}
          table.insert(champignons, newChampignion)
          explosionSound:play()
          table.remove(cities, j)
          table.remove(rocks, i)
          
          if #cities == 0 then
            isAlive = false
          end
        end
      end

      -- avec le joueur
      if CheckCollision(rock.x-rock.offset, rock.y-rock.offset, rock.img:getWidth(), rock.img:getHeight(), player.x, player.y, playerWidth, playerHeight) 
      and isAlive then
        newExplosion = {frame=0, x=rock.x+rock.offset-offsetExplosion, y=player.y-rock.offset}
        table.insert(explosions, newExplosion)
        explosionSound:play()
        table.remove(rocks, i)
        isAlive = false
      end
    end
  end
end


--  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
--  D  R  A  W
--  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
function love.draw(dt)
  love.graphics.setColor(59, 140, 185)
  love.graphics.rectangle( "fill", 0, 0, width, height )
  love.graphics.setColor(33, 30, 0)
  love.graphics.rectangle( "fill", 0, height-groundWidth, width, height )
    
  -- réinitialisation de la couleur
  love.graphics.setColor(255, 255, 255)  
  
  -- On affiche les nuages
  for i, cloud in ipairs(clouds) do
    love.graphics.draw(cloudImg, cloud.x, cloud.y)
  end
  
  -- On affiche les cités
  for i, city in ipairs(cities) do
    love.graphics.draw(city.img, city.x, city.y)
  end
  
  -- On affiche le player
  if isAlive then    
    love.graphics.draw(playerImg, sPlayer[player.frame], player.x, player.y)
  else
    love.graphics.print("Press 'R' to restart", love.graphics:getWidth()/2-50, love.graphics:getHeight()/2-groundWidth)
  end
  
  -- On affiche les ennemis
  for i, rock in ipairs(rocks) do
    love.graphics.draw(rock.img, rock.x, rock.y, rock.angle,1,1,rock.img:getWidth()/2, rock.img:getHeight()/2)
    --love.graphics.rectangle("line", rock.x-rock.offset, rock.y-rock.offset, rock.img:getWidth()/nbFrameRock, rock.img:getHeight())    
  end
  
  -- Gestions des Sprites Animés
  animation(bullets, laserImg, sLaser)
  animation(explosions, explosionImg, sExplosion)
  animation(champignons, champignonImg, sChampignon)
  
  -- On affiche le score et le logo ELECTRIC DREAMS
  love.graphics.print("Score : "..score, 10, love.graphics:getHeight()-20)  
  love.graphics.setFont(fontPixelArt)
  love.graphics.print("Electric Dreams", width-200, love.graphics:getHeight()-18)
  love.graphics.setFont(font16)
  
  if not gamePlay then
    afficheTitleScreen()
  end
  
  if debug then
    afficheDebug()
  end
  
  if helpScreen then
    afficheHelpScreen()
  end
  
  if not isAlive then 
    afficheGameOver()
    love.graphics.setFont(font16)
    love.graphics.print("Press 'R' to restart", love.graphics:getWidth()/2-50, love.graphics:getHeight()/2-groundWidth)
  end
end

function love.keypressed(key)
  -- affichage de l'écran d'aide
  if key == "f1" then
    if helpScreen then
      helpScreen = false
    else
      helpScreen = true
    end
  end
  
  -- gestion de la touche ESC
  if key == "escape" then
    if helpScreen then
      helpScreen = false
    elseif gamePlay then
      gamePlay = false
      isAlive = true
    else
      love.event.push('quit')
    end
  end
  
  -- gestion de la touche F10
  if key == "f10" then
    if debug == false then
      debug = true
    else
      debug = false
    end
  end
  
  -- gestion de la touche RETURN
  if key == "return" and not gamePlay then
    gamePlay = true
    initialize()
  end
end